package com.gic.haoban.manage.web.controller;

import com.gic.clerk.api.service.ClerkService;
import com.gic.enterprise.api.service.EnterpriseService;
import com.gic.enterprise.api.service.StoreGroupService;
import com.gic.enterprise.api.service.StoreService;
import com.gic.haoban.common.utils.HaobanResponse;
import com.gic.haoban.manage.api.service.DealSyncOperationApiService;
import com.gic.haoban.manage.api.service.DepartmentApiService;
import com.gic.haoban.manage.api.service.StaffApiService;
import com.gic.haoban.manage.api.service.StaffDepartmentRelatedApiService;
import com.gic.haoban.manage.web.auth.AuthRequestUtil;
import com.gic.haoban.manage.web.errCode.HaoBanErrCode;
import com.gic.haoban.manage.web.qo.SyncDealQO;
import com.gic.haoban.manage.web.vo.LoginVO;
import com.gic.redis.data.util.RedisUtil;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequestMapping("/sync")
public class SyncDealContoller extends WebBaseController {

    private static Logger logger = LoggerFactory.getLogger(SyncDealContoller.class);
    @Autowired
    private DepartmentApiService departmentApiService;

    @Autowired
    private StoreGroupService storeGroupService;
    @Autowired
    private StoreService storeService;
    @Autowired
    private StaffApiService staffApiService;

    @Autowired
    private EnterpriseService enterpriseService;
    @Autowired
    private ClerkService clerkService;

    @Autowired
    private StaffDepartmentRelatedApiService staffDepartmentRelatedApiService;

    @Autowired
    private DealSyncOperationApiService dealSyncOperationApiService;


    @RequestMapping("department-sync")
    @ResponseBody
    public HaobanResponse departmentBatchSync(@RequestBody SyncDealQO qo) {
        LoginVO login = (LoginVO) AuthRequestUtil.getSessionUser();
        String wxEnterpriseId = login.getWxEnterpriseId();
        String key = "haoban-sync-department-" + wxEnterpriseId;
        if (RedisUtil.getCache(key) != null) {
            return resultResponse(HaoBanErrCode.ERR_10011);
        }
        dealSyncOperationApiService.dealDepartment("111", login.getWxEnterpriseId(), qo.getAddDepartment(), qo.getEditDepartment());

        return resultResponse(HaoBanErrCode.ERR_1, key);

    }

    @RequestMapping("department-batch-sync-success")
    public HaobanResponse syncSuccess(String syncKey) {
        if (RedisUtil.getCache(syncKey) == null) {
            return resultResponse(HaoBanErrCode.ERR_1, true);
        } else {
            return resultResponse(HaoBanErrCode.ERR_1, false);
        }
    }


}
